# Twitter.py -- Acorn python plugin
#
# Saves the current image and sends it to Twitter to use as your avatar
#
# by Philippe Casgrain, philippe@casgrain.com
# March 19th, 2008

import objc, os
from Foundation import *
from AppKit import *

ACScriptSuperMenuTitle = None
ACScriptMenuTitle = "Save as Twitter Avatar"
ACShortcutKey = 't'
ACShortcutMask = "command control"
ACIsAction = True

twitter_user = "your_twitter_username"
twitter_pass = "your_twitter_password"


def main(image):
	# Save current file as a png in a temporary location
	doc      = NSDocumentController.sharedDocumentController().currentDocument()
	data     = doc.dataRepresentationOfType_('public.png')
	filePath = "/tmp/" + doc.fileName().lastPathComponent().stringByDeletingPathExtension() + ".png"
	
	# This will overwrite any file that may already be there
	data.writeToFile_atomically_(filePath, True)

	# Launch the ruby script that does the heavy lifting
	pluginPath = os.path.expanduser("~/Library/Application Support/Acorn/Plug-Ins/");
	os.system("ruby \"" + pluginPath + "TwitterUpload.rb\" \"" + filePath + "\" " + twitter_user + " " + twitter_pass)
	
	# Cleanup
	os.remove(filePath)
	
	return None
